/************************************************************************************
dijkstrairs
Copyright (c) 2010, International Rescue System Institute
All rights reserved.

Contact us if you use this software for sell.
If you use this software not for sell, you can use this software under BSD license.
See the files LICENSE.TXT and LICENSE-BSD.TXT for more details.                     
************************************************************************************/

//***************************************************************************************//
//* TestOutput.cpp							     2010.10.19 *//
//*											*//
//* Test Output RTMプログラム [Ver.0.1.0]						*//
//***************************************************************************************//


// -*- C++ -*-
/*!
 * @file  TestOutput.cpp
 * @brief Test Output for Path Planning
 * $Date$
 *
 * $Id$
 */

#include "TestOutput.h"

// Module specification
// <rtc-template block="module_spec">
static const char* testoutput_spec[] =
  {
    "implementation_id", "TestOutput",
    "type_name",         "TestOutput",
    "description",       "Test Output for Path Planning",
    "version",           "1.0.0",
    "vendor",            "IRS",
    "category",          "Map",
    "activity_type",     "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables

    ""
  };
// </rtc-template>

TestOutput::TestOutput(RTC::Manager* manager)
  : RTC::DataFlowComponentBase(manager),
    // <rtc-template block="initializer">
    m_PathIn("Path", m_Path),
    
    // </rtc-template>
	dummy(0)
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  registerInPort("Path", m_PathIn);
  
  // Set OutPort buffer
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

}

TestOutput::~TestOutput()
{
}


RTC::ReturnCode_t TestOutput::onInitialize()
{
	// <rtc-template block="bind_config">
	// Bind variables and configuration variable

	// </rtc-template>

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}



/*
RTC::ReturnCode_t TestOutput::onFinalize()
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

RTC::ReturnCode_t TestOutput::onActivated(RTC::UniqueId ec_id)
{

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

RTC::ReturnCode_t TestOutput::onDeactivated(RTC::UniqueId ec_id)
{

	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

RTC::ReturnCode_t TestOutput::onExecute(RTC::UniqueId ec_id)
{


	//-- [データ更新] -----------------------------------------------------------------------//

	if(m_PathIn.isNew()){										// 更新チェック

		m_PathIn.read();									// データ読み込み


		//-- [タイムスタンプ表示] -------------------------------------------------------//

		printf("\n[Timestamp] %lf\n",
			(double)m_Path.tm.sec + (double)m_Path.tm.nsec / 1000000000.0);			// メッセージ表示 [Timestamp]

		//-------------------------------------------------------------------------------//


		//-- [経路表示] -----------------------------------------------------------------//

		for(i = 0; i < (long int)m_Path.pose.length(); i++){

			printf("[Path     ] %lf - %lf - %lf\n", m_Path.pose[i].position.x,
				m_Path.pose[i].position.y, m_Path.pose[i].heading);			// メッセージ表示 [x, y, heading]

		}

		printf("\n");										// 改行

		//-------------------------------------------------------------------------------//


		//-- [復帰処理] -----------------------------------------------------------------//

		fflush(stdout);										// バッファフラッシュ [printf表示用]

		//-------------------------------------------------------------------------------//


	}

	//---------------------------------------------------------------------------------------//


	return RTC::RTC_OK;										// 戻り値 [正常終了]

}

/*
RTC::ReturnCode_t TestOutput::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/

/*
RTC::ReturnCode_t TestOutput::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}
*/



extern "C"
{

  void TestOutputInit(RTC::Manager* manager)
  {
    RTC::Properties profile(testoutput_spec);
    manager->registerFactory(profile,
                             RTC::Create<TestOutput>,
                             RTC::Delete<TestOutput>);
  }

};


