#!/bin/sh

# -bpython		: Pythonコンポーネントコード生成プログラム
# -bvcproject		: VC++プロジェクトファイル生成プログラム
# -bcxx			: C++コンポーネントコード生成プログラム
#
# --module-name		: モジュール名
# --module-desc		: モジュールの説明
# --module-version	: モジュールのバージョン
# --module-vendor	: モジュールのベンダ
# --module-category	: モジュールのカテゴリ
# --module-comp-type	: コンポーネントの型
# --module-act-type	: アクティビティタイプ
# --module-max-inst	: コンポネントインスタンスの最大数
#
# --inport		: 入力ポート定義
# --outport		: 出力ポート定義
# --service-idl		: サービスプロバイダIDLパス
# --service		: サービスプロバイダ定義
# --consumer-idl	: サービスコンシューマIDLパス
# --consumer		: サービスプロバイダ定義
# --config		: コンフィグレーションセット定義

rtc-template -bcxx \
	--module-name=Dijkstra \
	--module-desc='Path Planning' \
	--module-version=1.0.0 \
	--module-vendor=IRS \
	--module-category=Map \
	--module-comp-type=DataFlowComponent \
	--module-act-type=SPORADIC \
	--module-max-inst=1 \
	--inport=RobotPosition:TimedRobotPosition \
	--inport=GoalPosition:TimedRobotPosition \
	--inport=MeshData:TimedMapData \
	--outport=Path:TimedPath \
	--outport=MeshOrder:TimedMeshOrder \
	--consumer-idl=irs.idl \
	--config=01_location:std::string:kobe_green_space_park \
	--config=02_mapset:std::string:irs \
	--config=03_type:std::string:hazard \
	--config=04_originx:long:100000 \
	--config=05_originy:long:-100000 \
	--config=06_sizex:unsigned\ long:170000 \
	--config=07_sizey:unsigned\ long:80000 \
	--config=08_pixelsizex:unsigned\ long:1000 \
	--config=09_pixelsizey:unsigned\ long:1000 \
	--config=10_gui:std::string:on \
	--config=11_guiaddress:std::string:../gui/dijkstra \
	--config=12_ip:std::string:127.0.0.1 \
	--config=13_sendport:std::string:10008 \
	--config=14_receiveport:std::string:10007
